Hot News:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  AutoCAD ObjectARX und .NET
  dwg als Block einfügen

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   dwg als Block einfügen (234 mal gelesen)
Fiedel93felix
Mitglied
Konstrukteur


Sehen Sie sich das Profil von Fiedel93felix an!   Senden Sie eine Private Message an Fiedel93felix  Schreiben Sie einen Gästebucheintrag für Fiedel93felix

Beiträge: 444
Registriert: 19.02.2014

Autodesk Inventor 2017
AutoCAD Mechanical 2017
Microsoft Visual Basic 2010

erstellt am: 07. Okt. 2020 07:46    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo miteinander,

ich habe jetzt schon eine Weile probiert und ich bekomm es einfach nicht hin eine .dwg als Block an eine bestimmten Punkt einzufügen.
Ich steh da an irgendeinem Punkt auf dem Schlauch.

Könnte hier bitte jemand einen Beispielcode einstellen der funkioiniert?

------------------
----------------------------------
Mit freundlichen Grüßen

Felix

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4156
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools

erstellt am: 07. Okt. 2020 09:42    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Fiedel93felix 10 Unities + Antwort hilfreich

... ist sehr allgemein, deine Frage. Was genau will den nicht funktionieren? Wie sieht dein Code bisher aus?

Grüße!
Holger

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Fiedel93felix
Mitglied
Konstrukteur


Sehen Sie sich das Profil von Fiedel93felix an!   Senden Sie eine Private Message an Fiedel93felix  Schreiben Sie einen Gästebucheintrag für Fiedel93felix

Beiträge: 444
Registriert: 19.02.2014

Autodesk Inventor 2017
AutoCAD Mechanical 2017
Microsoft Visual Basic 2010

erstellt am: 07. Okt. 2020 11:00    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Also mein Plan ist eigentlich ganz einfach.
Ich will 2 Blöcke einfügen die einen bestimmten namen haben ("Anschluss1" und "Anschluss2")

Dazu wollte ich einfach erstmal einen Block einfügen und habe es schon mit verschiedenen Codes Probiert.
Zuletzt hatte ich folgenden Code:

Code:

Dim acCurDb As Autodesk.AutoCAD.DatabaseServices.Database
        acCurDb = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Database

        Using acTrans As Autodesk.AutoCAD.DatabaseServices.Transaction = acCurDb.TransactionManager.StartTransaction()

            Dim acBlkTbl As Autodesk.AutoCAD.DatabaseServices.BlockTable
            acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, Autodesk.AutoCAD.DatabaseServices.OpenMode.ForRead)

            Dim blkRecId As Autodesk.AutoCAD.DatabaseServices.ObjectId = Autodesk.AutoCAD.DatabaseServices.ObjectId.Null

            If Not acBlkTbl.Has("Baumkrone") Then
                Using acBlkTblRec As New Autodesk.AutoCAD.DatabaseServices.BlockTableRecord
                    acBlkTblRec.Name = "Baumkrone"

                    acBlkTblRec.Origin = New Autodesk.AutoCAD.Geometry.Point3d(0, 0, 0)

                    Using newdb As New Autodesk.AutoCAD.DatabaseServices.Database(True, False)

                        newdb.ReadDwgFile("‪O:\test.dwg", Autodesk.AutoCAD.DatabaseServices.FileOpenMode.OpenForReadAndAllShare, False, "")

                        acCurDb.Insert(Autodesk.AutoCAD.Geometry.Matrix3d.Displacement(New Autodesk.AutoCAD.Geometry.Vector3d(0, 0, 0)), newdb, True)

                    End Using

                    blkRecId = acBlkTblRec.Id
                End Using
            Else
                blkRecId = acBlkTbl("Baumkrone")
            End If


            If blkRecId <> Autodesk.AutoCAD.DatabaseServices.ObjectId.Null Then
                Using acBlkRef As New Autodesk.AutoCAD.DatabaseServices.BlockReference(New Autodesk.AutoCAD.Geometry.Point3d(10, 10, 10), blkRecId)

                    Dim acCurSpaceBlkTblRec As Autodesk.AutoCAD.DatabaseServices.BlockTableRecord
                    acCurSpaceBlkTblRec = acTrans.GetObject(acCurDb.CurrentSpaceId, Autodesk.AutoCAD.DatabaseServices.OpenMode.ForWrite)

                    acCurSpaceBlkTblRec.AppendEntity(acBlkRef)
                    acTrans.AddNewlyCreatedDBObject(acBlkRef, True)
                End Using
            End If

            acTrans.Commit()

        End Using


und bei der Zeile kommt ein Fehler:

Code:

newdb.ReadDwgFile("‪O:\test.dwg", Autodesk.AutoCAD.DatabaseServices.FileOpenMode.OpenForReadAndAllShare, False, "")

Fehler: eFilerError

------------------
----------------------------------
Mit freundlichen Grüßen

Felix

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4156
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools

erstellt am: 07. Okt. 2020 12:00    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Fiedel93felix 10 Unities + Antwort hilfreich

Ich denke, in dem True liegt der Fehler, welches du durch ein False ersetzen musst.:
Code:

Using newdb As New Autodesk.AutoCAD.DatabaseServices.Database(False, False)

Grüße!
Holger

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Fiedel93felix
Mitglied
Konstrukteur


Sehen Sie sich das Profil von Fiedel93felix an!   Senden Sie eine Private Message an Fiedel93felix  Schreiben Sie einen Gästebucheintrag für Fiedel93felix

Beiträge: 444
Registriert: 19.02.2014

Autodesk Inventor 2017
AutoCAD Mechanical 2017
Microsoft Visual Basic 2010

erstellt am: 07. Okt. 2020 13:30    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Nein das war leider nicht des Rätsels Lösung.

------------------
----------------------------------
Mit freundlichen Grüßen

Felix

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4156
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools

erstellt am: 07. Okt. 2020 13:41    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Fiedel93felix 10 Unities + Antwort hilfreich

Der fehlende Doppelbackslash im Dateipfad?

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Fiedel93felix
Mitglied
Konstrukteur


Sehen Sie sich das Profil von Fiedel93felix an!   Senden Sie eine Private Message an Fiedel93felix  Schreiben Sie einen Gästebucheintrag für Fiedel93felix

Beiträge: 444
Registriert: 19.02.2014

Autodesk Inventor 2017
AutoCAD Mechanical 2017
Microsoft Visual Basic 2010

erstellt am: 07. Okt. 2020 13:51    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Doppelbackslash hatte ich bei keinem Beispiel.

Hab es getestet, ist es auch nicht.

------------------
----------------------------------
Mit freundlichen Grüßen

Felix

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4156
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools

erstellt am: 07. Okt. 2020 14:10    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Fiedel93felix 10 Unities + Antwort hilfreich

ich nutze immer -> System.IO.FileShare.Read

Ich kenne das so von c# das ein Backslash als Doppelbackslash geschrieben werden muss oder vor die Zeichenkette ein @ gesetzt wird.

Code:

string _pfad = @"c:\Temp\";
// oder
string _pfad = "c:\\Temp\\";

Findet das Tool die Datei?

Code:

if(System.IO.File.Exists(@"c:\Temp\Test.dwg"))
{
...
}
else
{
...
}

Grüße!
Holger

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4156
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools

erstellt am: 07. Okt. 2020 14:12    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Fiedel93felix 10 Unities + Antwort hilfreich

Meine Standard-Funktion (c#) dafür sieht wie folgt aus:
Code:

/// <summary>
        /// Importiert eine Zeichnungsdatei als Blockdefinition
        /// </summary>
        /// <param name="Blockdatei">vollständiger DateiPfad</param>
        /// <returns></returns>
        internal static Boolean dtImportBlockDWG(this Database _db, Transaction _tr, String _Blockdatei, out ObjectId _BtrId, string _BlockName)
        {
            _BtrId = ObjectId.Null;
            Boolean _erg = false;
            bool _blockDefIsAnnotative = false;
            UnitsValue _insunits = 0;
            if (System.IO.File.Exists(_Blockdatei))
            {
                using (Database tempDb = new Database(false, false))
                {
                    try
                    {
                        tempDb.ReadDwgFile(_Blockdatei, System.IO.FileShare.Read, true, null);
                        _db.Insert(_BlockName, tempDb, true);
                        _blockDefIsAnnotative = tempDb.AnnotativeDwg;
                        _insunits = tempDb.Insunits;
                        _erg = true;
                    }
                    catch (AcRuntime.Exception _e) { AcApp.Application.ShowAlertDialog("006 - " + _e.Message); }
                }
            }
            if (_erg)
            {
                _BtrId = _db.dtGetBlockTableRecordId(_tr, _BlockName);

                using (BlockTableRecord _btr = (BlockTableRecord)_tr.GetObject(_BtrId, OpenMode.ForWrite))
                {
                    if (_blockDefIsAnnotative)
                    {
                        _btr.Annotative = AnnotativeStates.True;
                    }
                    _btr.Units = _insunits;
                }
            }
            return _erg;
        }


Grüße!
Holger

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Fiedel93felix
Mitglied
Konstrukteur


Sehen Sie sich das Profil von Fiedel93felix an!   Senden Sie eine Private Message an Fiedel93felix  Schreiben Sie einen Gästebucheintrag für Fiedel93felix

Beiträge: 444
Registriert: 19.02.2014

Autodesk Inventor 2017
AutoCAD Mechanical 2017
Microsoft Visual Basic 2010

erstellt am: 07. Okt. 2020 14:53    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Ich habe jetzt mal versucht die Datei zu finden

        If System.IO.File.Exists("‪O:\test.dwg") Then
            MsgBox("gefunden")
        Else
            MsgBox(" nicht gefunden")
        End If

        Exit Sub

Egal was ich mache es kommt immer "nicht gefunden".
Jemand eine Idee was ich noch ändern kann?

Ich habe auch versucht die Datei mal auf C: zu kopieren aber auch das bringt nichts.

------------------
----------------------------------
Mit freundlichen Grüßen

Felix

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4156
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools

erstellt am: 07. Okt. 2020 15:02    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Fiedel93felix 10 Unities + Antwort hilfreich

... dann versuche doch einmal herauszufinden, wie man einen Backslash  eines Dateipfades in vb.net angibt.

Zu den obigen Beispielen gäbe es auch noch die Variante den Backslash als einfachen Slash zu schreiben:

Code:

"c:/test.dwg"

Grüße!
Holger

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Fiedel93felix
Mitglied
Konstrukteur


Sehen Sie sich das Profil von Fiedel93felix an!   Senden Sie eine Private Message an Fiedel93felix  Schreiben Sie einen Gästebucheintrag für Fiedel93felix

Beiträge: 444
Registriert: 19.02.2014

Autodesk Inventor 2017
AutoCAD Mechanical 2017
Microsoft Visual Basic 2010

erstellt am: 07. Okt. 2020 15:10    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

hab ich schon alles versucht.

Das komisch dabei, ich habe bereits andere Funktionen wo ich auf Excel-Tabellen zugreife und hier musste ich nichts ändern im Pfad.

Bsp.: TabMatDatenbank = "W:\X-Materialübersichten\Materialübersicht.xls"

        If System.IO.File.Exists("‪O:\test.dwg") Then
            MsgBox("test gefunden")
        Else
            MsgBox("test nicht gefunden")
        End If


        If System.IO.File.Exists(TabMatDatenbank) Then
            MsgBox("Matb gefunden")
        Else
            MsgBox("Mat nicht gefunden")
        End If
Das erste findet er nicht, das 2. findet er.

------------------
----------------------------------
Mit freundlichen Grüßen

Felix

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4156
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools

erstellt am: 07. Okt. 2020 15:36    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Fiedel93felix 10 Unities + Antwort hilfreich

... dann bin ich raus. Dann muss es in vb.net andere Konventionen geben, wie man die Sonderzeichen Zeichen übergibt.

Hast du wirklich mit den von mir genannten Schreibweisen getestet? Wenn ja -> dann ist dein Fehler irgendwo anders.

Grüße!
Holger

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Fiedel93felix
Mitglied
Konstrukteur


Sehen Sie sich das Profil von Fiedel93felix an!   Senden Sie eine Private Message an Fiedel93felix  Schreiben Sie einen Gästebucheintrag für Fiedel93felix

Beiträge: 444
Registriert: 19.02.2014

Autodesk Inventor 2017
AutoCAD Mechanical 2017
Microsoft Visual Basic 2010

erstellt am: 07. Okt. 2020 15:39    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Ich habe es jetzt mit einer anderen DWG versucht welche er über File.exists findet aber auch hier steigt der Code dann bei der gleichen Zeile aus.

------------------
----------------------------------
Mit freundlichen Grüßen

Felix

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4156
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools

erstellt am: 07. Okt. 2020 15:46    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Fiedel93felix 10 Unities + Antwort hilfreich

... dann schau dir nochmal den von mir geposteten Code an - den nutze ich seit Jahren ohne Probleme. Ich kann dir mehr nicht helfen.

Grüße!
Holger

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Fiedel93felix
Mitglied
Konstrukteur


Sehen Sie sich das Profil von Fiedel93felix an!   Senden Sie eine Private Message an Fiedel93felix  Schreiben Sie einen Gästebucheintrag für Fiedel93felix

Beiträge: 444
Registriert: 19.02.2014

Autodesk Inventor 2017
AutoCAD Mechanical 2017
Microsoft Visual Basic 2010

erstellt am: 13. Jan. 2021 16:21    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Hallo miteinander,
ich habe jetzt nochmal etwas getestet und versuch Holgers Code in vb zu Übernehmen, was aktuell wie folgt aussieht:

Code:

            Dim _db As Database = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Database
            Dim _tr As Transaction
            Dim _Blockdatei As String
            Dim _BtrId As ObjectId
            Dim _BlockName As String
            _BtrId = ObjectId.Null


            _Blockdatei = "S:\Austausch\Fiedler\Zeichnung1.dwg"
            If System.IO.File.Exists(_Blockdatei) Then
                MsgBox("gefunden")
            Else
                MsgBox("nicht gefunden")
            End If
            _BlockName = "TestEinf"


            Dim _erg As Boolean = False
            Dim _blockDefIsAnnotative As Boolean = False
            Dim _insunits As UnitsValue = 0


            If System.IO.File.Exists(_Blockdatei) Then

                Using tempDb As Database = New Database(False, False)
                    Try

                        tempDb.ReadDwgFile(_Blockdatei, System.IO.FileShare.Read, True, "")


                        _db.Insert(_BlockName, tempDb, True)


                        _blockDefIsAnnotative = tempDb.AnnotativeDwg


                        _insunits = tempDb.Insunits


                        _erg = True


                    Catch ex As Exception
                        MsgBox("006 - " & vbCrLf & ex.Message)
                    End Try
                End Using
            End If

            Fehlerzeile = 11

            Exit Sub
            If _erg = True Then
                _BtrId = _db.dtGetBlockTableRecordId(_tr, _BlockName)

                Using _btr As BlockTableRecord = _tr.GetObject(_BtrId, OpenMode.ForWrite)

                    If _blockDefIsAnnotative = True Then
                        _btr.Annotative = AnnotativeStates.True
                    End If
                    _btr.Units = _insunits
                End Using

            End If

            Return _erg


Allerdings weis ich nicht wie ich die beiden Zeilen ändern muss:

Code:
_BtrId = _db.dtGetBlockTableRecordId(_tr, _BlockName)

(Fehler: _db.dtGetBlockTableRecordId ist kein Member von Database)

Code:
Return _erg

(Fehler:'Eine Return-Anweisung in "Sub" oder "Set" kann keinen Wert zurückgeben.)

Kann mir hier jemad weiterhelfen?

Was ich an dem Code auch nicht verstehe, Es findet sich nicht einmal InsertBlock oder ähnliches im Code.
Wie wird der Block dann an welchem Punkt auf der Zeichnung eingefügt???

------------------
----------------------------------
Mit freundlichen Grüßen

Felix

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4156
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools

erstellt am: 13. Jan. 2021 16:37    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für Fiedel93felix 10 Unities + Antwort hilfreich

dir fehlt die Funktion dtGetBlockTableRecordId
Der Name sagt, das die ObjectId der Blockdefinition ermittelt wird. Ich denke, soetwas ist auch schnell selbst programmiert.

Du finbest im geposteten Code kein Einfügen, weil die Routine lediglich den Import als Blockdefinition erledigt. Das Einfügen ist dann wieder in anderen Bibliotheks-Funktionen enthalten, da dies ja ganz verschieden passieren könnte.

Grüße!
Holger

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Fiedel93felix
Mitglied
Konstrukteur


Sehen Sie sich das Profil von Fiedel93felix an!   Senden Sie eine Private Message an Fiedel93felix  Schreiben Sie einen Gästebucheintrag für Fiedel93felix

Beiträge: 444
Registriert: 19.02.2014

Autodesk Inventor 2017
AutoCAD Mechanical 2017
Microsoft Visual Basic 2010

erstellt am: 14. Jan. 2021 07:16    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Ja aber genau das einfügen war ja das was ich von anfang an gesucht habe, da ist mir auch egal ob der Block dann in den Blockdefinitionen hinterlegt ist oder nicht.

------------------
----------------------------------
Mit freundlichen Grüßen

Felix

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Fiedel93felix
Mitglied
Konstrukteur


Sehen Sie sich das Profil von Fiedel93felix an!   Senden Sie eine Private Message an Fiedel93felix  Schreiben Sie einen Gästebucheintrag für Fiedel93felix

Beiträge: 444
Registriert: 19.02.2014

Autodesk Inventor 2017
AutoCAD Mechanical 2017
Microsoft Visual Basic 2010

erstellt am: 14. Jan. 2021 08:36    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Ich habe wollte es jetzt mit folgendem Code probieren

Code:

Imports Microsoft.Office.Interop
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.ApplicationServices


            Dim _Blockdatei As String = "S:\Austausch\Fiedler\Zeichnung1.dwg"

            Dim tAcadDoc As Document = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument


            Dim tBlRef As BlockReference
            Dim tBlName As String : tBlName = _Blockdatei
            Dim tPnt As New Point3d(0, 0, 0)
            tBlRef = tAcadDoc.ModelSpace.InsertBlock(tPnt, tBlName, 1, 1, 1, 0)


Kann mir jemand sagen wie ich tAcadDoc definieren muss damit der Code funktioniert?

Bei tAcadDoc.ModelSpace kommt der Fehler:
BC30456 '"ModelSpace" ist kein Member von "Document"

------------------
----------------------------------
Mit freundlichen Grüßen

Felix

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2021 CAD.de | Impressum | Datenschutz